'' Auswahlmenu grx info:
''   choice.bmp     size( 800, 600 )   pos(   0,   0 )      methode( pset )
''   hud.bmp        size( 800, 168 )   pos(   0, 600 )      methode( pset )
''   arrowup.bmp    size( 110,  70 )   pos( 678, 122 )      methode( pset )
''   arrowdown.bmp  size( 110,  70 )   pos( 678, 522 )      methode( pset )
''   button.bmp     size( 188, 148 )   pos( 612, 620 )      methode( trans )
''   empty.bmp      size( 182, 132 )   pos(  27, 131 )      methode( trans )    step( 228, 160 )
''   choiceh.bmp    size( 184, 134 )   pos(  26, 130 )      methode( trans )    step( 228, 160 )
''   buttonh.bmp    size( 188, 148 )   pos( 612, 620 )      methode( trans )
''   arrowuph.bmp   size( 110,  70 )   pos( 678, 122 )      methode( trans )
''   arrowdownh.bmp size( 110,  70 )   pos( 678, 522 )      methode( trans )

Const as String datapath = "../data/"

#Define MBrelease       &h00
#Define MBhit           &h01
#Define MBhold          &h02

'------------------------------------------------------------------------------------------------------'

type Image as any ptr

type SceneInfo
    ScenePath   as ZString ptr
    SceneName   as ZString ptr
    SceneImage  as Image
    ObjectCount as Integer
    Highscore   as UInteger
end type

type SceneObject
    ObjectImage as Image
    ObjectName  as ZString ptr
    
    ObjectPosX  as Integer
    ObjectPosY  as Integer
    
    ObjectSizeX as Integer 'ObjectImage.X / 3
    ObjectSizeY as Integer
    
    Objectflag  as Integer
    ObjectAlpha as Integer
end type

type SceneFile
    ScenePath   as ZString ptr
    SceneName   as ZString ptr
    Background  as Image
    
    ObjectCount as Integer
    Objects     as SceneObject ptr
    
    Highscore   as Integer
end type

'------------------------------------------------------------------------------------------------------'

Namespace Global
    Dim Language as String
    Dim numFont  as Image
    Dim bigFont  as Image
End Namespace

'------------------------------------------------------------------------------------------------------'

'*(Haupt-neben-funktion) Ldt alle ntigen Infos aller verfgbarer Scenen (fr SceneChoice())
Declare Function ScenePreload(byref SceneCount as Integer) as SceneInfo ptr
'*(Haupt-neben-funktion) Ldt die Scene-Daten (fr ScenePlay())
Declare Function SceneLoad(byval Path as String) as SceneFile ptr
'hilfsfunktion, prft ob eine Datei existiert
Declare Function FileCheck(byval filename as String) as Integer
'gibt eine integer zufallszahl zwischen imin und imax zurck
Declare Function getRandom(Byval imin as Integer, Byval imax as Integer) as Integer
'einfacher bitmap-loader
Declare Function LoadImage(byval filename as String) as Image
'!(Hauptfunktion) Auswahlmen: gibt die Daten der ausgewhlten Scene zurck
Declare Function SceneChoice() as SceneFile ptr
'erweiterte getMouse funktion
Declare Sub MouseUpdate(byref X as Integer, byref Y as Integer, byref B as Integer)
'!(Hauptfunktion) eigentliche Spiel-Routine: ''note: lscht die Scene-Daten am ende aus den Speicher
Declare Sub ScenePlay(byref Scene as SceneFile ptr)
'hilfsfunktion, zeichnet einen String in den Hud
Declare Sub DrawHudString(byval HudString as String)
'hilfsfunktion, zeichnet eine Integer (Zeit) auf den Zeit/Button platz
Declare Sub DrawTime(byval pTime as Integer)
'Leert die von ScenePreload() zurckgegebenen Daten aus den Speicher
Declare Sub ScenePreloadFree(byval SceneCount as Integer, byref SceneInfList as SceneInfo ptr)
'Leert die von SceneLoad() zurckgegebenen Daten aus den Speicher
Declare Sub SceneFree(byref Scene as SceneFile ptr) 

'------------------------------------------------------------------------------------------------------'

    Declare Sub Init5in15()
    Declare Sub Close5in15()

    Sub Init5in15()
        Dim F as Integer
        Dim L as Integer
        
        Dim configGRX   as Image
        Dim deutschGRX  as Image
        Dim deutschhGRX as Image
        Dim englishGRX  as Image
        Dim englishhGRX as Image
        Dim tempGRX     as Image
        Dim as Integer  MX,MY,MB
        
        If FileCheck("config.cfg") Then
            F = Freefile
            
            Open "config.cfg" for binary access read as #F
                get #F,,L
            Close #F
            
        Else
            screenres 800,400,32,,&h04
            
            configGRX   = LoadImage(datapath & "config.bmp")
            deutschGRX  = LoadImage(datapath & "buttonde.bmp")
            deutschhGRX = LoadImage(datapath & "buttondeh.bmp")
            englishGRX  = LoadImage(datapath & "buttonen.bmp")
            englishhGRX = LoadImage(datapath & "buttonenh.bmp")
            
            Do
                MouseUpdate(MX,MY,MB)
                
                Screenlock
                    put (0,0),configGRX,pset
                    
                    If (MX > 100) and (MY >  75) and (MX < 700) and (MY < 175) Then
                        put (100,75),deutschhGRX,trans
                        If (MB = MBhit) Then L = 1
                    Else
                        put (100,75),deutschGRX,trans
                    End If

                    If (MX > 100) and (MY > 225) and (MX < 700) and (MY < 325) Then
                        put (100,225),englishhGRX,trans
                        If (MB = MBhit) Then L = -1
                    Else
                        put (100,225),englishGRX,trans
                    End If

                Screenunlock
                
                sleep 10
            Loop until L
            
            Imagedestroy(configGRX)
            Imagedestroy(deutschGRX)
            Imagedestroy(deutschhGRX)
            Imagedestroy(englishGRX)
            Imagedestroy(englishhGRX)
            
            F = Freefile
            Open "config.cfg" for binary access write as #F
                put #F,,L
            Close #F
        End If
        
        Select Case L
            Case 1
                Global.Language = "DE"
            Case Else
                Global.Language = "EN"
        End Select
        
        screenres 800,768,32,,&h04 ''NO-SWITCH
        Windowtitle "FBCC#4 5in15 (2013)"
        
        Global.numFont = LoadImage(datapath & "tnums.bmp")
        Global.bigFont = LoadImage(datapath & "bigfont.bmp")
    End Sub
    
    Sub Close5in15()
        If Global.numFont Then Imagedestroy(Global.numFont)
        If Global.bigFont Then Imagedestroy(Global.bigFont)
    End Sub

'------------------------------------------------------------------------------------------------------'

Function getRandom(Byval imin as Integer, Byval imax as Integer) as Integer
    Dim rndnum as Integer
    Dim as Integer min, max
    
    min = imin : max = imax
    If min>max then swap min,max
    
    rndnum = min + int( rnd*( max - (min-1) ) ) 
        
    return rndnum
End Function

Function FileCheck(byval filename as String) as Integer
    Dim as Integer F     = Freefile
    Dim as Integer Check
    Check = Open (filename for binary access read as #F)
        
    If (Check = 0) Then
        Close #F
        Function = -1
    Else
        Function = 0
    End If
End Function

Function LoadImage(byval filename as String) as Image
    If (FileCheck(filename) = 0) Then return 0
    
    Dim F         as Integer = Freefile
    Dim BMPHeader as String*2
    Dim BMPWidth  as UInteger
    Dim BMPHeight as UInteger
    Dim BMPImage  as Image
    
    Open fileName for binary access read as #F
        GET #F,   , BMPHeader
        
        If BMPHeader<>"BM" Then
            Close #F
            return 0
        End If
        
        GET #F, 19, BMPWidth
        GET #F,   , BMPHeight
    Close #F
    
    BMPImage = Imagecreate(BMPWidth,BMPHeight)
    BLoad filename,BMPImage
    
    Return BMPImage
End Function

Sub MouseUpdate(byref X as Integer, byref Y as Integer, byref B as Integer)
    Static as Double  holdtimer
    Static as Integer MouseButton
    Dim    as Integer MB
    
    getmouse X,Y,,MB
    
    If (MB > -1) and (MB and 1) Then
        Select Case MouseButton
            Case MBrelease
                MB = MBhit
            Case MBhit
                MB = MBhold
                holdtimer = timer
            Case MBhold
                If (timer-holdtimer > 0.75) Then 
                    MB = MBrelease
                Else
                    MB = MBhold
                End If
        End Select
    Else
        MB = MBrelease
    End If
    MouseButton = MB
    B = MB
End Sub

Function ScenePreload(byref SceneCount as Integer) as SceneInfo ptr
    Dim as Integer        F 
    Dim as SceneInfo ptr  SceneInfList
    
    Dim as String         SceneFolder 
    Dim as Integer        SceneListLen = 0
    Dim as any ptr        Temp
    
    Dim as String         SceneNameDE
    Dim as String         SceneNameEN
    Dim as Integer        ObjectCount
    
    Dim as Integer        Highscore
    Dim as String         HighscoreString
    
    SceneFolder = Dir(datapath & "*.*", &h10)

    Do
        If (SceneFolder <> "") Then
            If (SceneFolder <> ".") and (SceneFolder <> "..") Then 
                Temp = 0 : SceneNameDE = "" : SceneNameEN = "" : ObjectCount = 0
                
                If FileCheck(datapath & SceneFolder & "/scene.dat") Then
                    If SceneInfList Then 
                        Temp = reallocate( SceneInfList, (SceneListLen+1) * SizeOf(SceneInfo) )
                        SceneInfList = Temp
                    Else
                        SceneInfList = callocate( SizeOf(SceneInfo) )
                    End If
                
                    'folder
                    SceneInfList[SceneListLen].ScenePath = callocate( Len(SceneFolder)+1 )
                    *SceneInfList[SceneListLen].ScenePath = SceneFolder
                
                    'name + objectcount
                    F = Freefile
                    Open (datapath & SceneFolder & "/scene.dat") for input access read as #F
                        Input #F, SceneNameDE
                        Input #F, SceneNameEN
                        Input #F, ObjectCount
                    Close #F
                
                    Select Case Global.Language
                        Case "DE"
                            SceneInfList[SceneListLen].SceneName  = callocate( Len(SceneNameDE)+1 )
                            *SceneInfList[SceneListLen].SceneName = SceneNameDE
                        Case Else
                            SceneInfList[SceneListLen].SceneName  = callocate( Len(SceneNameEN)+1 )
                            *SceneInfList[SceneListLen].SceneName = SceneNameEN
                    End Select
                
                    SceneInfList[SceneListLen].ObjectCount = ObjectCount
                
                    'image
                    SceneInfList[SceneListLen].SceneImage = LoadImage(datapath & SceneFolder & "/scene.bmp")
                    
                    'Highscore
                    If (FileCheck(datapath & SceneFolder & "/scene.hsc")) Then
                        F = Freefile
                        Open (datapath & SceneFolder & "/scene.hsc") for binary access read as #F
                            get #F,,Highscore
                        Close #F

                        HighscoreString = str(Highscore)
                        Draw String SceneInfList[SceneListLen].SceneImage,(55,60),"Highscore",&hFFFF00
                        Draw String SceneInfList[SceneListLen].SceneImage,(91-(Len(HighscoreString)*4),80),HighscoreString,&hFFFFFF
                        
                    End If
                    
                    '
                    SceneListLen += 1
                End If
            End If
        End If
        
        SceneFolder = Dir("", &h10)
    
    Loop while (SceneFolder <> "")
    
    SceneCount = SceneListLen
    
    return SceneInfList
End Function

Sub ScenePreloadFree(byval SceneCount as Integer, byref SceneInfList as SceneInfo ptr)
    For p as Integer = 0 to SceneCount-1
        deallocate(SceneInfList[p].ScenePath)
        deallocate(SceneInfList[p].SceneName)
        Imagedestroy(SceneInfList[p].SceneImage)
        SceneInfList[p].ObjectCount = 0
    Next p
    deallocate (SceneInfList)
End Sub

Sub SceneFree(byref Scene as SceneFile ptr) 
    If (Scene) Then
        If (Scene -> ScenePath)  Then Deallocate (Scene -> ScenePath)
        If (Scene -> SceneName)  Then Deallocate (Scene -> SceneName)
        If (Scene -> Background) Then Imagedestroy (Scene -> Background)
        
        For o as Integer = 0 to ((Scene -> ObjectCount) -1)
            If (Scene -> Objects[o].ObjectImage) Then imagedestroy (Scene -> Objects[o].ObjectImage)
            If (Scene -> Objects[o].ObjectName)  Then deallocate (Scene -> Objects[o].ObjectName)
            
            Scene -> Objects[o].ObjectPosX  = 0 
            Scene -> Objects[o].ObjectPosY  = 0
            Scene -> Objects[o].ObjectSizeX = 0
            Scene -> Objects[o].ObjectSizeY = 0
            Scene -> Objects[o].Objectflag  = 0
            Scene -> Objects[o].ObjectAlpha = 0
        Next o
        
        Scene -> ObjectCount = 0
        Delete[] (Scene -> Objects)
        
        Scene -> Highscore = 0
        
        Delete Scene
        
        Scene = 0
    End If
End Sub

Function SceneLoad(byval Path as String) as SceneFile ptr
        Dim as String  ScenePath = (datapath & Path & "/")
        Dim as Integer F        
        
        If (FileCheck(ScenePath & "scene.dat"     ) = 0) Then return 0
        If (FileCheck(ScenePath & "background.bmp") = 0) Then return 0
        
        Dim as SceneFile ptr Scene = NEW SceneFile
        
        Scene -> ScenePath = Callocate(Len(ScenePath)+1)
        *Scene -> ScenePath = ScenePath
        
        'Background (Image)
        Scene -> Background = LoadImage(ScenePath & "background.bmp")
        
        'Objects
        Dim as String  SceneNameDE, SceneNameEN
        Dim as String  ObjectNameDE, ObjectNameEN
        F = Freefile
        
        Open (ScenePath & "scene.dat") for input access read as #F
            Input #F,SceneNameDE
            Input #F,SceneNameEN
                
            Select Case Global.Language
                Case "DE"
                    Scene -> SceneName = callocate(Len(SceneNameDE)+1)
                    *Scene -> SceneName = SceneNameDE
                Case else
                    Scene -> SceneName = callocate(Len(SceneNameEN)+1)
                    *Scene -> SceneName = SceneNameEN
            End Select 
                
            Input #F,Scene -> ObjectCount
            Scene -> Objects = NEW SceneObject[(Scene -> ObjectCount)]
            
            For o as Integer = 0 to ((Scene -> ObjectCount) -1)
                Input #F,ObjectNameDE
                Input #F,ObjectNameEN
                
                Select Case Global.Language
                    Case "DE"
                        Scene -> Objects[o].ObjectName = callocate(Len(ObjectNameDE)+1)
                        *Scene -> Objects[o].ObjectName = ObjectNameDE
                    Case else
                        Scene -> Objects[o].ObjectName = callocate(Len(ObjectNameEN)+1)
                        *Scene -> Objects[o].ObjectName = ObjectNameEN
                End Select                
                
                Input #F,Scene -> Objects[o].ObjectPosX
                Input #F,Scene -> Objects[o].ObjectPosY
                
                If FileCheck(ScenePath & "obj/" & str(o+1) & ".bmp") Then
                    Scene -> Objects[o].ObjectImage = LoadImage( ScenePath & "obj/" & str(o+1) & ".bmp" ) 
                
                    Imageinfo (Scene -> Objects[o].ObjectImage, Scene -> Objects[o].ObjectSizeX, Scene -> Objects[o].ObjectSizeY)
                    Scene -> Objects[o].ObjectSizeX /= 3
                
                    Scene -> Objects[o].Objectflag = 0
                End If
                
                Scene -> Objects[o].ObjectAlpha = 255
            Next o
        Close #F
        
        'Highscore
        If (FileCheck(ScenePath & "scene.hsc")) Then
            F = Freefile
            Open (ScenePath & "scene.hsc") for binary access read as #F
                get #F,,Scene -> Highscore
            Close #F
        End If
        
        return Scene
End Function

Sub DrawTime(byval pTime as Integer)
    Dim TimeString as String  = str(pTime)
    Dim num        as Integer
    
    Dim PosX       as Integer = 720 - ( (Len(TimeString)/2) * 57 )
    Dim PosY       as Integer = 660
    
    For c as Integer = 0 to Len(TimeString)-1
        num = TimeString[c] - 48
        
        put (PosX,PosY),Global.numFont,(num*57,0)-((num*57)+56,94),trans
        PosX += 57
    Next c
End Sub

Sub DrawHudString(byval HudString as String)
    Dim PosX       as Integer = 340 - ( (Len(HudString)/2) * 25 )
    Dim PosY       as Integer = 670
    Dim PutX       as Integer
    Dim PutY       as Integer
    Dim ascchar    as Integer
    
    For c as Integer = 0 to Len(HudString)-1
        ascchar = HudString[c]
        
        PutX = ((ascchar mod 16) * 32)
        PutY = ((ascchar \   16) * 32)
        
        put (PosX,PosY),Global.bigFont,(PutX,PutY)-(PutX+31,PutY+31),trans
        
        PosX += 25
    Next c
End Sub

Function SceneChoice() as SceneFile ptr
        Dim as Integer Updatenote  =  -2
        Dim as Integer Updateflag  
        Dim as Integer Scrolling   =   0 '' (0+n to 8+n)
        Dim as Integer SceneCount  =   0 '' Anzahl existierender Szenen
        Dim as String  Key     
        
        ''GRX
        Dim as Image choiceGRX     = LoadImage(datapath & "choice.bmp"    )
        Dim as Image hudGRX        = LoadImage(datapath & "hud.bmp"       )
        Dim as Image arrowupGRX    = LoadImage(datapath & "arrowup.bmp"   )
        Dim as Image arrowdownGRX  = LoadImage(datapath & "arrowdown.bmp" )
        Dim as Image buttonGRX     = LoadImage(datapath & "button.bmp"    )
        Dim as Image emptyGRX      = LoadImage(datapath & "empty.bmp"     )
        Dim as Image choicehGRX    = LoadImage(datapath & "choiceh.bmp"   )
        Dim as Image buttonhGRX    = LoadImage(datapath & "buttonh.bmp"   )
        Dim as Image arrowuphGRX   = LoadImage(datapath & "arrowuph.bmp"  )
        Dim as Image arrowdownhGRX = LoadImage(datapath & "arrowdownh.bmp")
        Dim as Image tempGRX
        
        ''Szenen preview
        Dim as SceneInfo ptr PreviewScene = ScenePreload(SceneCount)
        
        ''Mouse
        Dim as Integer MX, MY, MB
        
        Do
            Updateflag = -1 : MouseUpdate(MX,MY,MB) : Key = Inkey
            
            'scene
            For c as Integer = 0 to 8
                If ( (c + Scrolling) < SceneCount) Then
                    If (MX > (  26 + ((c mod 3) * 228) )) and _
                       (MY > ( 130 + ((c \   3) * 160) )) and _
                       (MX < ( 210 + ((c mod 3) * 228) )) and _
                       (MY < ( 264 + ((c \   3) * 160) )) Then 
                            
                            Updateflag = c
                    End If
                End If
            Next c
            
            'exit button
            If (MX > 612) and (MY > 620) and (MX < 800) and (MY < 768) Then
                If ((Point(MX-612,MY-620,buttonGRX) and &hFFFFFF) <> &hFF00FF) Then Updateflag = 9
            End If
                
            'arrow up
            If (MX > 678) and (MY > 122) and (MX < 788) and (MY < 192) Then
                If ( SceneCount > 9) Then 
                    Updateflag = 10
                End If
            End If

            'arrow down
            If (MX > 678) and (MY > 522) and (MX < 788) and (MY < 592) Then
                If ( SceneCount > 9) Then 
                    Updateflag = 11
                End If
            End If

            If Key = chr(255,107) Then Updateflag = 99
            
            ''Update
            If (Updatenote <> Updateflag) Then
                
                Screenlock
                    put (0  ,   0), choiceGRX, pset
                    put (0  , 600), hudGRX   , pset
                    put (612, 620), buttonGRX, trans
                    
                    '' arrows
                    If (SceneCount > 9) Then
                        put (678, 122), arrowupGRX, pset
                        put (678, 522), arrowdownGRX, pset
                    End If
                    
                    '' preview
                    For p as Integer = 0 to 8
                        tempGRX = 0
                        
                        If ((p + Scrolling) < SceneCount) and ((p + Scrolling) > -1)Then
                            tempGRX = PreviewScene[(p + Scrolling)].SceneImage
                        Else
                            tempGRX = emptyGRX
                        End If
                        
                        put ( 27 + ( (p mod 3) * 228 ), 131 + ( (p \ 3) * 160 ) ), tempGRX, trans
                    Next p
                    
                    '' highlight
                    Select Case Updateflag
                        Case 0,1,2,3,4,5,6,7,8 'scene
                            put ( 26 + ( (Updateflag mod 3) * 228 ), 130 + ( (Updateflag \ 3) * 160 ) ), choicehGRX, trans
                            DrawHudString(*PreviewScene[(Updateflag + Scrolling)].SceneName)
                        Case 9                 'exit button
                            Put (612, 620), buttonhGRX, trans
                        Case 10                'arrow up
                            put (678, 122), arrowuphGRX, trans
                        Case 11                'arrow down
                            put (678, 522), arrowdownhGRX, trans
                    End Select
                        
                Screenunlock
                
                Updatenote = Updateflag
            End If
            
            If (Updatenote > -1) andalso (MB = MBhit) Then
                Select Case Updatenote
                    Case 10
                        If ((Scrolling - 3) > -1) Then 
                            Scrolling -= 3 : Updatenote = -1
                        End If
                    Case 11
                        If ((Scrolling + (8+3)) < SceneCount) Then 
                            Scrolling += 3 : Updatenote = -1
                        End If
                    Case Else
                        Exit Do
                End Select
            End If
            
            If (Updatenote = 99) Then Exit Do
            sleep 1
        Loop 
        
        ''
        
        Imagedestroy(choiceGRX)
        Imagedestroy(hudGRX)
        Imagedestroy(arrowupGRX)
        Imagedestroy(arrowdownGRX)
        Imagedestroy(buttonGRX)
        Imagedestroy(emptyGRX)
        Imagedestroy(choicehGRX)
        Imagedestroy(buttonhGRX)
        Imagedestroy(arrowuphGRX)
        Imagedestroy(arrowdownhGRX)
        
        If (Updatenote = 9) or (Updatenote = 99) Then 
            Function = 0
        Else
            Function = SceneLoad(*PreviewScene[Updatenote + Scrolling].ScenePath)
        End If
        
        ScenePreloadFree(SceneCount,PreviewScene)
End Function


Sub ScenePlay(byref Scene as SceneFile ptr)
    'Objectflag 
    '  0   = hidden
    '  1   = found
    '  2   = -
    
    Dim five as String*5
    Dim fc   as Integer
    Dim F    as Integer
    
    Do
        five[fc] = getRandom(0,Scene -> ObjectCount-1)
        For c as Integer = 0 to fc-1
            If five[c]=five[fc] Then Continue do
        Next c
        fc += 1
    Loop until fc = 5
    
    Dim as Integer Score
    Dim as Integer Bonus
    
    Dim as Integer ContinueLoop
    Dim as Integer ContinueTime
    Dim as Integer PlayTime 
    Dim as Double  ScoreTime
    Dim as Double  NowTime  
    Dim as Double  AlphaT   
    
    Dim as Image   readyGRX  
    Dim as Image   hudGRX    = LoadImage(datapath & "hud.bmp" )
    Dim as Integer MX, MY, MB
    
    'ready?
    Screenlock
        put (0,0),Scene -> Background,pset
        put (0,600),hudGRX,pset
        DrawTime(15)
        DrawHudString(*Scene -> SceneName)
        Select Case Global.Language
            Case "DE"
                readyGRX = LoadImage(datapath & "readyde.bmp")
            Case else
                readyGRX = LoadImage(datapath & "readyen.bmp")
        End Select
        put (0,250),readyGRX,trans
    Screenunlock
    
    Do
        MouseUpdate(MX,MY,MB)
    Loop while (MB <> MBhit)
    
    
    Imagedestroy (readyGRX)
    
    NowTime   = Timer
    ScoreTime = NowTime
    fc = 0
    
    Do
        ContinueLoop = 0 : ContinueTime = 0
        For c as Integer = 0 to 4
            If (Scene -> Objects[five[c]].Objectflag <> 2) Then ContinueLoop = 1
            If (Scene -> Objects[five[c]].Objectflag  = 0) Then ContinueTime = 1
        Next c
        
        If ContinueTime Then PlayTime = fix(16-(Timer-NowTime))
        
        MouseUpdate (MX,MY,MB)
        
        If (MB = MBhit) Then
            If (MX >= Scene -> Objects[five[fc]].ObjectPosX) and (MY >= Scene -> Objects[five[fc]].ObjectPosY) and _
               (MX < Scene -> Objects[five[fc]].ObjectPosX + Scene -> Objects[five[fc]].ObjectSizeX) and (MY < Scene -> Objects[five[fc]].ObjectPosY + Scene -> Objects[five[fc]].ObjectSizeY) and _
               (Scene -> Objects[five[fc]].Objectflag = 0) Then
                    If ((point((MX - Scene -> Objects[five[fc]].ObjectPosX)+ Scene -> Objects[five[fc]].ObjectSizeX,_
                                MY - Scene -> Objects[five[fc]].ObjectPosY,  Scene -> Objects[five[fc]].ObjectImage) and &hFFFFFF) = &hFFFFFF) Then
                                
                            Scene -> Objects[five[fc]].Objectflag = 1
                            ''ADD SCORE!!
                            'test - NOTE! bessere Berechnung einfallen lassen...
                            Score += int((PlayTime-(Timer-ScoreTime))*1000.123)
                            ScoreTime = Timer
                            
                            fc += 1 'nchste Objekt
                            
                    End If
            End IF
        End If
        
        
        Screenlock
            put (0,0),Scene -> Background,pset
            
            For o as Integer = 0 to Scene -> ObjectCount -1
                Select Case Scene -> Objects[o].Objectflag
                    Case 0
                        put (Scene -> Objects[o].ObjectPosX, Scene -> Objects[o].ObjectPosY), Scene -> Objects[o].ObjectImage, _
                        (0,0)-(Scene -> Objects[o].ObjectSizeX-1, Scene -> Objects[o].ObjectSizeY-1), trans
                    Case 1
                        put (Scene -> Objects[o].ObjectPosX, Scene -> Objects[o].ObjectPosY), Scene -> Objects[o].ObjectImage, _
                        (Scene -> Objects[o].ObjectSizeX*2, 0)-((Scene -> Objects[o].ObjectSizeX*2)+(Scene -> Objects[o].ObjectSizeX-1), Scene -> Objects[o].ObjectSizeY-1), Alpha, Scene -> Objects[o].ObjectAlpha
                        If ((Timer-AlphaT) > 0.01) Then 
                            Scene -> Objects[o].ObjectAlpha -= 3
                            If (Scene -> Objects[o].ObjectAlpha < 20) Then
                                Scene -> Objects[o].Objectflag  = 2
                                Scene -> Objects[o].ObjectAlpha = 0
                            End If
                        End If
                    Case Else
                        ' -
                End Select
            Next o
            
            put (0,600),hudGRX,pset
            
            ''Draw Playtime
            DrawTime(PlayTime)
            
            ''Draw Objectname
            If (fc<5) Then DrawHudString (*Scene -> Objects[five[fc]].ObjectName)
            
            ''Draw Score
            Draw String (10,10),str(Score),&hFFFF00
            
        Screenunlock
        
        If ((Timer-AlphaT) > 0.01) Then AlphaT = Timer
        
        sleep 1
    Loop While (PlayTime > 0) and (ContinueLoop = 1)
    
    ''HIGHSCORE-SCENE!
    Dim as Integer MainScore = Score
    
    If PlayTime Then
        Do
            
            If PlayTime Then
                PlayTime -= 1
                Bonus    += 1000
            End If
            
            If Bonus Then
                Bonus    -= 100
                Score    += 100
            End If
            

            Screenlock
                put (0,0),Scene -> Background,pset
            
                For o as Integer = 0 to Scene -> ObjectCount -1
                    If (Scene -> Objects[o].Objectflag = 0) Then
                        put (Scene -> Objects[o].ObjectPosX, Scene -> Objects[o].ObjectPosY), Scene -> Objects[o].ObjectImage, _
                        (0,0)-(Scene -> Objects[o].ObjectSizeX-1, Scene -> Objects[o].ObjectSizeY-1), trans
                    End If
                Next o
                
                put (0,600),hudGRX,pset
                
                ''Draw Playtime
                DrawTime(PlayTime)
                
                ''Draw Score
                Draw String (10,10),str(MainScore),&hFFFF00
                Draw String (30,30),"+ Time Bonus : " & str(Score),&hFFEE00
            Screenunlock
            
            sleep 10
        Loop while Bonus
        
        
        If (Score > Scene -> Highscore) Then 
            Screenlock
                Select Case Global.Language
                    Case "DE"
                        DrawHudString("Neuer Rekord")
                    Case Else
                        DrawHudString("New Highscore")
                End Select
            Screenunlock
            
            ''Save Highscore
            F = Freefile
            Open (*Scene -> Scenepath & "scene.hsc") for binary access write as #F
                put #F,,Score
            Close #F
        End If

    End If
    
    
    NowTime = Timer
    Do
        MouseUpdate(MX,MY,MB)
        If ((Timer - NowTime) > 5) Then Exit Do
    Loop until MB=MBhit
    
    
    SceneFree(Scene)
    Imagedestroy (hudGRX)
    
End Sub

